/*
 *  Wrapper for CCBSIM - Using CCBSIM as a VCR Replacement
 *
 *  Compiled with Turbo C 2.0 - the "free" compiler from
 *  http://community.borland.com/museum/
 *
 *  Public domain by Stefan Reuther <Streu@gmx.de>
 */

#include <process.h>
#include <stdio.h>

void die(char* msg)
{
    fprintf(stderr, "%s\n", msg);
    exit(1);
}

char* respawn = "planets.exe";
char* opts = 0;

int main(int argc, char** argv)
{
    FILE* fp;
    unsigned char vcrinit[8];
    char path[80];
    char vcrfile[100];

    /* whom do we want to respawn? */
    while (*++argv) {
        if (strncmp(*argv, "respawn=", 8) == 0)
            respawn = *argv + 8;
        else if (strncmp(*argv, "options=", 8) == 0)
            opts = *argv + 8;
    }

    /* get path */
    fp = fopen("path.dat", "rb");
    if(!fp)
	path[0] = 0;
    else {
	size_t s = fread(path, 1, sizeof(path)-1, fp);
	fclose(fp);
	path[s] = 0;
    }

    /* get player number */
    sprintf(vcrfile, "%svcrinit.tmp", path);
    fp = fopen(vcrfile, "rb");
    if(!fp)
	die("can't open VCRINIT.TMP");
    if(fread(vcrinit, 1, 8, fp) != 8)
	die("invalid VCRINIT.TMP");
    fclose(fp);
    if(vcrinit[2] != 0x9B && vcrinit[3] != 2)
	die("invalid VCRINIT.TMP");

    /*
     *  execute CCBSIM, then chain to PLANETS.EXE
     *  add additional parameters to CCBSIM between `path' and `"/f"'
     */
    sprintf(vcrfile, "%svcr%d.dat", path, vcrinit[0]);
    spawnl(P_WAIT, "ccbsim.exe", "ccbsim.exe", path, "/f", vcrfile, opts, (char*) 0);
    execl(respawn, respawn, path, (char*) 0);

    /* NOTREACHED */
    return 0;
}
